regina::NAugTriSolidTorus Class Reference
Standard Triangulations and Subcomplexes

Represents an augmented triangular solid torus component of a triangulation. More...

`#include <subcomplex/naugtrisolidtorus.h>`

Inheritance diagram for regina::NAugTriSolidTorus:

## Public Member Functions

virtual | ~NAugTriSolidTorus ()
| Destroys this augmented solid torus; note that the corresponding triangular and layered solid tori will also be destroyed. More...
NAugTriSolidTorus * | clone () const
| Returns a newly created clone of this structure. More...
const NTriSolidTorus & | getCore () const
| Returns the triangular solid torus at the core of this triangulation. More...
const NLayeredSolidTorus * | getAugTorus (int annulus) const
| Returns the layered solid torus attached to the requested annulus on the boundary of the core triangular solid torus. More...
NPerm4 | getEdgeGroupRoles (int annulus) const
| Returns a permutation describing the role played by each top level edge group of the layered solid torus glued to the requested annulus of the core triangular solid torus. More...
unsigned long | getChainLength () const
| Returns the number of tetrahedra in the layered chain linking two of the boundary annuli of the core triangular solid torus. More...
int | getChainType () const
| Returns the way in which a layered chain links two of the boundary annuli of the core triangular solid torus. More...
int | getTorusAnnulus () const
| Returns the single boundary annulus of the core triangular solid torus to which a layered solid torus is attached. More...
bool | hasLayeredChain () const
| Determines whether the core triangular solid torus has two of its boundary annuli linked by a layered chain as described in the general class notes. More...
NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::NStandardTriangulation
virtual | ~NStandardTriangulation ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NAugTriSolidTorus * | isAugTriSolidTorus (const NComponent *comp)
| Determines if the given triangulation component is an augmented triangular solid torus. More...
Static Public Member Functions inherited from regina::NStandardTriangulation
static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Static Public Attributes

static const int | CHAIN_NONE
| Indicates that this augmented triangular solid torus contains no layered chain. More...
static const int | CHAIN_MAJOR
| Indicates that this augmented triangular solid torus contains a layered chain attached as described by NTriSolidTorus::areAnnuliLinkedMajor(). More...
static const int | CHAIN_AXIS
| Indicates that this augmented triangular solid torus contains a layered chain attached as described by NTriSolidTorus::areAnnuliLinkedAxis(). More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents an augmented triangular solid torus component of a triangulation.

Such a component is obtained as follows. Begin with a three-tetrahedron triangular solid torus (as described by NTriSolidTorus). Observe that the three axis edges divide the boundary into three annuli. Then take one of the following actions.

- To each of these annuli, glue a layered solid torus. Note that the degenerate (2,1,1) layered solid torus (i.e., a one-triangle mobius strip) is allowed and corresponds to simply gluing the two triangles of the annulus together.
- To one of these annuli, glue a layered solid torus as described above. Join the other two annuli with a layered chain in either the manner described by NTriSolidTorus::areAnnuliLinkedMajor() or the manner described by NTriSolidTorus::areAnnuliLinkedAxis().

It will be assumed that all layered solid tori other than the degenerate (2,1,1) will have (3,2,1) layered solid tori at their bases. That is, layered solid tori that begin with the degenerate (2,1,1) and layer over the boundary of the mobius strip are not considered in this class.

Note that (unless a (1,1,0) layered solid torus is used with the 0 edge glued to an axis edge) the resulting space will be a Seifert fibred space over the 2-sphere with at most three exceptional fibres.

Of the optional NStandardTriangulation routines, getManifold() is implemented for most augmented triangular solid tori and getHomologyH1() is not implemented at all.

Test:
  Included in the test suite.

## Constructor & Destructor Documentation

virtual regina::NAugTriSolidTorus::~NAugTriSolidTorus | ( |  | ) |

virtual

Destroys this augmented solid torus; note that the corresponding triangular and layered solid tori will also be destroyed.

## Member Function Documentation

NAugTriSolidTorus* regina::NAugTriSolidTorus::clone | ( |  | ) | const

Returns a newly created clone of this structure.

Returns
  a newly created clone.

const NLayeredSolidTorus * regina::NAugTriSolidTorus::getAugTorus | ( | int | annulus | ) | const

inline

Returns the layered solid torus attached to the requested annulus on the boundary of the core triangular solid torus.

If the layered solid torus is a degenerate (2,1,1) mobius band (i.e., the two triangles of the corresponding annulus have simply been glued together), `null` will be returned.

Parameters

  annulus | specifies which annulus to examine; this must be 0, 1 or 2.

Returns
  the corresponding layered solid torus.

unsigned long regina::NAugTriSolidTorus::getChainLength | ( |  | ) | const

inline

Returns the number of tetrahedra in the layered chain linking two of the boundary annuli of the core triangular solid torus.

Note that this count does not include any of the tetrahedra actually belonging to the triangular solid torus.

Returns
  the number of tetrahedra in the layered chain, or 0 if there is no layered chain linking two boundary annuli.

int regina::NAugTriSolidTorus::getChainType | ( |  | ) | const

inline

Returns the way in which a layered chain links two of the boundary annuli of the core triangular solid torus.

This will be one of the chain type constants defined in this class.

Returns
  the type of layered chain, or CHAIN_NONE if there is no layered chain linking two boundary annuli.

const NTriSolidTorus & regina::NAugTriSolidTorus::getCore | ( |  | ) | const

inline

Returns the triangular solid torus at the core of this triangulation.

Returns
  the core triangular solid torus.

NPerm4 regina::NAugTriSolidTorus::getEdgeGroupRoles | ( | int | annulus | ) | const

inline

Returns a permutation describing the role played by each top level edge group of the layered solid torus glued to the requested annulus of the core triangular solid torus.

See NLayeredSolidTorus::getTopEdge() for details regarding edge groups.

If the permutation returned is `p`, edge group `p[0]` will be glued to an axis edge, group `p[1]` will be glued to a major edge and group `p[2]` will be glued to a minor edge. `p[3]` will always be 3.

Even if the corresponding layered solid torus is a degenerate (2,1,1) mobius band (i.e., getAugTorus() returns `null`), the concept of edge groups is still meaningful and this routine will return correct results.

Parameters

  annulus | specifies which annulus to examine; this must be 0, 1 or 2. It is the layered solid torus glued to this annulus whose edge groups will be described.

Returns
  a permutation describing the roles of the corresponding top level edge groups.

NManifold* regina::NAugTriSolidTorus::getManifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::NStandardTriangulation.

int regina::NAugTriSolidTorus::getTorusAnnulus | ( |  | ) | const

inline

Returns the single boundary annulus of the core triangular solid torus to which a layered solid torus is attached.

This routine is only meaningful if the other two annuli are linked by a layered chain.

The integer returned will be 0, 1 or 2; see the NTriSolidTorus class notes for how the boundary annuli are numbered.

Returns
  the single annulus to which the layered solid torus is attached, or -1 if there is no layered chain (and thus all three annuli have layered solid tori attached).

bool regina::NAugTriSolidTorus::hasLayeredChain | ( |  | ) | const

inline

Determines whether the core triangular solid torus has two of its boundary annuli linked by a layered chain as described in the general class notes.

Returns
  `true` if and only if the layered chain described in the class notes is present.

static NAugTriSolidTorus* regina::NAugTriSolidTorus::isAugTriSolidTorus | ( | const NComponent * | comp | ) |

static

Determines if the given triangulation component is an augmented triangular solid torus.

Parameters

  comp | the triangulation component to examine.

Returns
  a newly created structure containing details of the augmented triangular solid torus, or `null` if the given component is not an augmented triangular solid torus.

std::ostream& regina::NAugTriSolidTorus::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

std::ostream& regina::NAugTriSolidTorus::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

void regina::NAugTriSolidTorus::writeTextLong | ( | std::ostream & | out | ) | const

virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

## Member Data Documentation

const int regina::NAugTriSolidTorus::CHAIN_AXIS

static

Indicates that this augmented triangular solid torus contains a layered chain attached as described by NTriSolidTorus::areAnnuliLinkedAxis().

const int regina::NAugTriSolidTorus::CHAIN_MAJOR

static

Indicates that this augmented triangular solid torus contains a layered chain attached as described by NTriSolidTorus::areAnnuliLinkedMajor().

const int regina::NAugTriSolidTorus::CHAIN_NONE

static

Indicates that this augmented triangular solid torus contains no layered chain.

The documentation for this class was generated from the following file:

- subcomplex/naugtrisolidtorus.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).